import logging

from typing import Sequence

from ec2init import Procedure, Plan

from ec2init.plans.hello_procedure import HelloWorldProcedure

logger = logging.getLogger(__name__)

class HelloWorldPlan(Plan):
    """
    Example plan
    """
    def __init__(self, name: str) -> None:
        self.name = name
        self.counter = 0

    def create(self) -> Sequence[Procedure]:
        plan = []
        if self.counter < 2:
            proc0 = HelloWorldProcedure("proc0", "executing proc0")
            plan.append(proc0)
            logger.debug("%s - Added proc0", self.name)

            proc1 = HelloWorldProcedure("proc1", "executing proc1")
            plan.append(proc1)
            logger.debug("%s - Added proc1", self.name)

            if self.counter < 1:
                proc2 = HelloWorldProcedure("proc2", "executing proc2")
                plan.append(proc2)
                logger.debug("%s - Added proc2", self.name)

            self.counter = self.counter + 1

        return plan

    def report_error(self, error_message: str) -> None:
        pass

    def report_configuration_error(self, error_message: str) -> None:
        pass