import logging

from typing import List

from ec2init import Procedure

logger = logging.getLogger(__name__)

class HelloWorldProcedure(Procedure):
    """
    Example procedure
    """
    def __init__(self, name: str, message: str) -> None:
        self.name = name
        
        self.message = message

    def pre(self) -> None:
        pass
    
    def execute(self) -> List[Procedure]:
        logger.info("%s - Executing: %s", self.name, self.message)
        return []

    def rollback(self) -> None:
        logger.warning("%s - Rolling back", self.name)
