import logging
import configparser
import pathlib

from pathlib import Path
from typing import List

from ec2init import Procedure

logger = logging.getLogger(__name__)

class DeactivateLogReport(Procedure):
    def __init__(self, name: str,config: configparser.ConfigParser, check_file: Path):
        self.name = name
        self.config = config
        self.check_file = check_file

    def execute(self) -> List[Procedure]:
        # Remove the metrics deamon from kagent services
        kagent_conf_dir = self.config.get(
            'general', 'kagent_conf_dir', fallback="/srv/hops/kagent/etc")
        services_file = pathlib.Path(kagent_conf_dir, "services")
        services = configparser.ConfigParser()
        services.read(str(services_file))

        if 'Monitoring-cloud-metrics-collector' in services:
            del services['Monitoring-cloud-metrics-collector']
        
        with open(str(services_file), 'w') as fd:
            services.write(fd)

        if self.check_file:
            self.check_file.touch()
        
        return []

    def rollback(self) -> None:
        pass