import logging
import configparser
import subprocess

from pathlib import Path
from typing import List

from ec2init import Procedure
from ec2init.utils.exceptions import Ec2InitFatalException

logger = logging.getLogger(__name__)

class RestoreDeletedBlocks(Procedure):
    def __init__(self, name: str,config: configparser.ConfigParser, check_file: Path):
        self.name = name
        self.config = config
        self.check_file = check_file

    def execute(self) -> List[Procedure]:
        logger.info("Restoring the deleted blocks")
        try:
            subprocess.run(["su - hdfs -c '/srv/hops/hadoop/bin/hdfs namenode -rollbackDeletedCloudBlocks'" ], stdout=subprocess.PIPE, shell=True, check=True)
        except subprocess.CalledProcessError as error:
            raise Ec2InitFatalException("Failed to restore the blocks in the filesystem")
        
        if self.check_file:
            self.check_file.touch()
        
        return []

    def rollback(self) -> None:
        pass