import logging
import time

from typing import List

from ec2init import Procedure
from ec2init.utils.system import SystemUtils

logger = logging.getLogger(__name__)

class StartConsul(Procedure):
    def __init__(self, name: str) -> None:
        self.name = name

    def pre(self) -> None:
        pass

    def execute(self) -> List[Procedure]:
        logger.info("%s - Starting execution", self.name)
        SystemUtils.execute_command(["systemctl", "enable", "consul"], timeout=120)
        SystemUtils.execute_command(["systemctl", "start", "consul"], timeout=120)
        SystemUtils.execute_command(["systemctl", "restart", "dnsmasq"], timeout=120)
        # Give it some time
        time.sleep(5)
        logger.info("%s - Started Consul", self.name)
        return []

    def rollback(self):
        pass