from enum import Enum
from typing import List, Dict, Tuple

class DockerImageName(Enum):
    Base = "base"
    Filebeat = "filebeat"
    OnlineFS = "onlinefs"
    Git = "git"
    Airflow = "airflow"
    FlyingDuck = "flyingduck"
    TestConnector = "testconnector"


class DockerUtils:

    @staticmethod
    def getDockerImagesInfo(input : str) -> Dict[DockerImageName, str]:
        return dict([DockerUtils._split_dict_item(e) for e in input.split(",") if e.strip() != ""])

    @staticmethod
    def _split_dict_item(input :str) -> Tuple[DockerImageName, str]:
        out = input.split(':')
        return (DockerImageName(out[0]), out[1])
